OpenStack Image Registry and Delivery Service (Glance)

update_image in glance.client doesn't add content-length so the swift backend can't chunk

Reported by Vish Ishaya on 2011-09-09
18
This bug affects 2 people
Affects Status Importance Assigned to Milestone
Glance
High
Jay Pipes
Diablo
Undecided
Unassigned
glance (Ubuntu)
High
Scott Moser

Bug Description

Code was added to add_image in glance.client to send in the content length, so that glance can chunk the file if it is over 5G. This code also needs to be added to update_image. Snapshotting in nova relies on client.update_image and it is breaking with large images sent to a swift backend because it excedes the 5G limit of swift.

Jay Pipes (jaypipes) on 2011-09-09
Changed in glance:
status: New → Triaged
importance: Undecided → High
milestone: none → 2011.3
assignee: nobody → Jay Pipes (jaypipes)

Reviewed: https://review.openstack.org/412
Committed: http://github.com/openstack/glance/commit/6cfff16f2dc22a870bfe3808a7895dfbbaa11369
Submitter: Jenkins
Branch: master

 status fixcommitted
 done

commit 6cfff16f2dc22a870bfe3808a7895dfbbaa11369
Author: Jay Pipes <email address hidden>
Date: Fri Sep 9 13:03:19 2011 -0400

    Fixes LP Bug#845788

    glance.client.image_update needed to calculate size so that Glance's Swift
    driver can do chunking properly for large objects.

    Change-Id: Iafe8034a710cff53a0caa3ae5e9ee3a3adda19f8

Changed in glance:
status: Triaged → Fix Committed
Thierry Carrez (ttx) on 2011-09-22
Changed in glance:
status: Fix Committed → Fix Released
Scott Moser (smoser) wrote :

It would appear, from a missing commit and my experience, that the fix for this did not make it into the glance diablo release.
The commit reported to have fixed this is at [1], and viewing the affected file (glance/client.py) in the milestone-proposed [2] branch would appear not to have that change.

[1] https://github.com/openstack/glance/commit/6cfff16f2dc22a870bfe3808a7895dfbbaa11369
[2] https://github.com/openstack/glance/blob/milestone-proposed/glance/client.py

Scott Moser (smoser) on 2011-09-27
Changed in glance (Ubuntu):
status: New → In Progress
importance: Undecided → High
assignee: nobody → Scott Moser (smoser)
milestone: none → ubuntu-11.10
tags: added: server-o-rs
Jay Pipes (jaypipes) wrote :

Yep, Thierry noticed this this morning. Sorry about that :(

-jay

Changed in glance:
status: Fix Released → Fix Committed
milestone: 2011.3 → essex-1
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package glance - 2011.3-0ubuntu3

---------------
glance (2011.3-0ubuntu3) oneiric; urgency=low

  [Scott Moser]
  * fix bug with glance and swift driver that resulted in zero length
    images. (LP: #845788)

  [Chuck Short]
  * Make streaming images from swift actually usuable.
    (LP: #850425)
 -- Chuck Short <email address hidden> Tue, 27 Sep 2011 14:49:05 -0400

Changed in glance (Ubuntu):
status: In Progress → Fix Released
Mark McLoughlin (markmc) on 2011-09-28
tags: added: diablo-backport
Thierry Carrez (ttx) on 2011-11-17
Changed in glance:
status: Fix Committed → Fix Released

Reviewed: https://review.openstack.org/1770
Committed: http://github.com/openstack/glance/commit/536435f5300df054a26520002f6acaa094755179
Submitter: Jenkins
Branch: stable/diablo

 tag in-stable-diablo
 done

commit 536435f5300df054a26520002f6acaa094755179
Author: Jay Pipes <email address hidden>
Date: Fri Sep 9 13:03:19 2011 -0400

    Fixes LP Bug#845788

    glance.client.image_update needed to calculate size so that Glance's Swift
    driver can do chunking properly for large objects.

    (cherry picked from commit 6cfff16f2dc22a870bfe3808a7895dfbbaa11369)

    Change-Id: Iafe8034a710cff53a0caa3ae5e9ee3a3adda19f8

Thierry Carrez (ttx) on 2012-04-05
Changed in glance:
milestone: essex-1 → 2012.1
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Duplicates of this bug

Other bug subscribers